#ifndef INCLUDED_LOGGING_HPP_2008_08_02_0000
#define INCLUDED_LOGGING_HPP_2008_08_02_0000

#include <iostream>
#include <ostream>
#include <stdexcept>
#include <Ice/Ice.h>
#ifndef WIN32
#include <unistd.h>
#endif

#define MATT_EXCEPTION_DEBUGGING(x) \
  try { \
    x; \
  } \
  catch() { \
    MATT_EXCEPTION_LOGGING; \
  }

#define MATT_EXCEPTION_LOGGING \
  try { \
    throw; \
  } \
  catch (::Ice::Exception const & e) { \
    ::std::ostringstream what; \
    what \
      << '[' << __FILE__ << ':' << __LINE__ << "] " << e; \
    std::string const & str = what.str(); \
    MATT_DEBUG(what.str()); \
    throw ::std::runtime_error(str); \
  }

#define MATT_DEBUG_LOG(message) \
  ::matt::debug( \
    __FILE__, \
    __LINE__, \
    (message))

namespace matt {

  template < 
    typename FILE, 
    typename LINE, 
    typename MESSAGE >
  void debug(
    FILE file, 
    LINE line, 
    MESSAGE message) {
    ::std::clog 
#ifndef WIN32
      << "PID("     << getpid()  << ") "
#endif
      << "FILE("    << file
      << ":"        << line      << ") "
      << message    << ::std::endl;
  }
}

#endif 

