package matt.applications;

import matt.protocol.Mediator;
import matt.protocol.Runtime;

import org.apache.log4j.Logger;

public class Server extends Ice.Application {

  static private final Logger log = Logger.getLogger(Server.class);
  
  public static void main(
    String[] args) {
    Server server = new Server();
    server.main("matt.server", args);
  }
  
  @Override
  public int run(
    String[] args) {
    Runtime runtime = new Runtime(args, communicator());
    log.info("Starting Server...");
    final Mediator mediator = new Mediator(runtime);
    runtime.register(mediator);
    log.info("Server Waiting for shutdown...");
    runtime.waitForShutdown();
    return 0;
  }
}
