package matt.implementation;


import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import matt.adapters.MessageTarget;


public class CompositeMessageTarget
  implements
    MessageTarget {
  
  private final List<MessageTarget> targets = new LinkedList<MessageTarget>();
  
  public CompositeMessageTarget(final Iterator<MessageTarget> targets) {
    while(targets.hasNext()) {
      this.targets.add(targets.next());
    }
  }

  public void putMessage(
    String message) {
    for (final MessageTarget target : targets) {
      target.putMessage(message);
    }
  }

  public void bubbleException(
    Exception e) {  
    for (final MessageTarget target : targets) {
      target.bubbleException(e);
    }
  }

  public void dispose() {
    // TODO Auto-generated method stub
  }
}
