package matt.implementation;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;

import org.apache.log4j.Logger;

import matt.adapters.MessageEntity;

public abstract class EchoMessageEntity
  implements
    MessageEntity {

  static private final Logger log = Logger.getLogger(EchoMessageEntity.class);
  protected final MessageEntity delegate;

  public EchoMessageEntity(
    final MessageEntity delegate) {
    this.delegate = delegate;
  }

  public void bubbleException(
    final Exception e) {
    OutputStream stream = new ByteArrayOutputStream();
    PrintStream writer = new PrintStream(stream);
    e.printStackTrace(writer);
    log.info("bubbleException: " + writer.toString());
    delegate.bubbleException(e);
  }
}
