package matt.implementation;

import org.apache.log4j.Logger;

import matt.adapters.MessageSource;

public class EchoMessageSource
  extends
    EchoMessageEntity
  implements
    MessageSource {

  static private final Logger log = Logger.getLogger(EchoMessageSource.class);
  static private final NoSpewLogger noSpew = new NoSpewLogger(log);
  private final MessageSource delegate;

  public EchoMessageSource(
    final MessageSource delegate) {
    super(delegate);
    this.delegate = delegate;
  }

  public String getMessage() {
    final String message = delegate.getMessage();
    noSpew.info("getMessage: " + message);
    return message;
  }

  public boolean hasMessage() {
    final boolean value = delegate.hasMessage();
    noSpew.info("hasMessage:" + value);
    return value;
  }

  public void dispose() {
    noSpew.dispose();
  }
}
