package matt.implementation;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;

import matt.adapters.MessageSource;
import matt.adapters.MessageTarget;

public class Terminal
  implements
    MessageSource,
    MessageTarget {

  private List<String> messages = new LinkedList<String>();

  public String getMessage() {
    synchronized (messages) {
      return messages.remove(0);
    }
  }

  public void putMessage(
    String message) {
    System.out.println("Received Message: " + message);
  }

  public boolean hasMessage() {
    synchronized (messages) {
      InputStreamReader stream = new InputStreamReader(System.in);
      BufferedReader reader = new BufferedReader(stream);
      try {
        messages.add(reader.readLine());
      }
      catch (IOException e) {
        e.printStackTrace();
      }
      return messages.size() != 0;
    }
  }

  public void bubbleException(
    Exception e) {
    final OutputStream stream = new ByteArrayOutputStream();
    PrintWriter writer = new PrintWriter(stream);
    e.printStackTrace(writer);
    putMessage(stream.toString());
  }

  public void dispose() {    
  }

}
